diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_ameth.c openssl-1.0.0q/crypto/dh/dh_ameth.c
--- openssl-1.0.0q.orig/crypto/dh/dh_ameth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_ameth.c	2017-04-25 16:23:40.180526572 +0200
@@ -55,13 +55,19 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
 #include <openssl/dh.h>
 #include <openssl/bn.h>
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
+
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static void int_dh_free(EVP_PKEY *pkey)
 	{
@@ -90,7 +96,7 @@
 		goto err;
 		}
 
-	pstr = pval;	
+	pstr = (ASN1_STRING *)pval;
 	pm = pstr->data;
 	pmlen = pstr->length;
 
@@ -170,7 +176,7 @@
 	if (penc)
 		OPENSSL_free(penc);
 	if (pval)
-		ASN1_STRING_free(pval);
+		ASN1_STRING_free((ASN1_STRING *)pval);
 
 	return 0;
 	}
@@ -205,7 +211,7 @@
 		goto decerr;
 
 
-	pstr = pval;	
+	pstr = (ASN1_STRING *)pval;
 	pm = pstr->data;
 	pmlen = pstr->length;
 	if (!(dh = d2i_DHparams(NULL, &pm, pmlen)))
@@ -353,7 +359,7 @@
 	else
 		ktype = "PKCS#3 DH Parameters";
 
-	m= OPENSSL_malloc(buf_len+10);
+	m = (unsigned char *)OPENSSL_malloc(buf_len+10);
 	if (m == NULL)
 		{
 		reason=ERR_R_MALLOC_FAILURE;
@@ -466,14 +472,13 @@
 	return do_dh_print(bp, x, 4, NULL, 0);
 	}
 
-const EVP_PKEY_ASN1_METHOD dh_asn1_meth = 
-	{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dh_ameth__dh_asn1_meth,
 	EVP_PKEY_DH,
 	EVP_PKEY_DH,
 	0,
 
-	"DH",
-	"OpenSSL PKCS#3 DH method",
+	(char *)"DH",
+	(char *)"OpenSSL PKCS#3 DH method",
 
 	dh_pub_decode,
 	dh_pub_encode,
@@ -495,6 +500,7 @@
 	dh_param_print,
 
 	int_dh_free,
+	0,
+	0,
 	0
-	};
-
+	);
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_asn1.c openssl-1.0.0q/crypto/dh/dh_asn1.c
--- openssl-1.0.0q.orig/crypto/dh/dh_asn1.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_asn1.c	2017-04-25 16:23:40.181526699 +0200
@@ -56,12 +56,17 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/dh.h>
 #include <openssl/objects.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* Override the default free and new methods */
 static int dh_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
@@ -79,15 +84,15 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(DHparams, dh_cb) = {
-	ASN1_SIMPLE(DH, p, BIGNUM),
-	ASN1_SIMPLE(DH, g, BIGNUM),
-	ASN1_OPT(DH, length, ZLONG),
-} ASN1_SEQUENCE_END_cb(DH, DHparams)
+ASN1_SEQUENCE_cb(DHparams, dh_cb)
+	ASN1_SIMPLE(DH, p, BIGNUM)
+	ASN1_SIMPLE(DH, g, BIGNUM)
+	ASN1_OPT(DH, length, ZLONG)
+ASN1_SEQUENCE_END_cb(DH, DHparams)
 
 IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname(DH, DHparams, DHparams)
 
 DH *DHparams_dup(DH *dh)
 	{
-	return ASN1_item_dup(ASN1_ITEM_rptr(DHparams), dh);
+	return (DH *)ASN1_item_dup(ASN1_ITEM_rptr(DHparams), dh);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_check.c openssl-1.0.0q/crypto/dh/dh_check.c
--- openssl-1.0.0q.orig/crypto/dh/dh_check.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_check.c	2017-04-25 16:23:40.181526699 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/dh.h>
 
@@ -70,6 +72,7 @@
  * should hold.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int DH_check(const DH *dh, int *ret)
 	{
 	int ok=0;
@@ -118,6 +121,7 @@
 	if (q != NULL) BN_free(q);
 	return(ok);
 	}
+#endif
 
 int DH_check_pub_key(const DH *dh, const BIGNUM *pub_key, int *ret)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_err.c openssl-1.0.0q/crypto/dh/dh_err.c
--- openssl-1.0.0q.orig/crypto/dh/dh_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_err.c	2017-04-25 16:23:40.182526547 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/dh.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_gen.c openssl-1.0.0q/crypto/dh/dh_gen.c
--- openssl-1.0.0q.orig/crypto/dh/dh_gen.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_gen.c	2017-04-25 16:23:40.183527792 +0200
@@ -61,8 +61,11 @@
  *  - Geoff
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/dh.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_key.c openssl-1.0.0q/crypto/dh/dh_key.c
--- openssl-1.0.0q.orig/crypto/dh/dh_key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_key.c	2017-04-25 16:23:40.185527487 +0200
@@ -56,11 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DH
 #include <openssl/bn.h>
 #include <openssl/rand.h>
 #include <openssl/dh.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int generate_key(DH *dh);
 static int compute_key(unsigned char *key, const BIGNUM *pub_key, DH *dh);
@@ -81,21 +85,21 @@
 	return dh->meth->compute_key(key, pub_key, dh);
 	}
 
-static DH_METHOD dh_ossl = {
-"OpenSSL DH Method",
-generate_key,
-compute_key,
-dh_bn_mod_exp,
-dh_init,
-dh_finish,
-0,
-NULL,
-NULL
-};
+OPENSSL_PREFIX_CONST_ITEM(static, DH_METHOD, dh_ossl, libopeay)
+  CONST_ITEM_ENTRY_START(name,OPERA_OPENSSL_STRINGS("OpenSSL DH Method"))
+  CONST_ITEM_ENTRY_SINGLE(generate_key, generate_key)
+  CONST_ITEM_ENTRY_SINGLE(compute_key, compute_key)
+  CONST_ITEM_ENTRY_SINGLE(bn_mod_exp, dh_bn_mod_exp)
+  CONST_ITEM_ENTRY_SINGLE(init, dh_init)
+  CONST_ITEM_ENTRY_SINGLE(finish, dh_finish)
+  CONST_ITEM_ENTRY_SINGLE(flags, 0)
+  CONST_ITEM_ENTRY_SINGLE(app_data, NULL)
+  CONST_ITEM_ENTRY_SINGLE(generate_params, NULL)
+CONST_ITEM_ENTRY_END;
 
 const DH_METHOD *DH_OpenSSL(void)
 {
-	return &dh_ossl;
+	return &OPENSSL_GLOBAL_ITEM_NAME(dh_ossl);
 }
 
 static int generate_key(DH *dh)
@@ -261,3 +265,4 @@
 		BN_MONT_CTX_free(dh->method_mont_p);
 	return(1);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_lib.c openssl-1.0.0q/crypto/dh/dh_lib.c
--- openssl-1.0.0q.orig/crypto/dh/dh_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_lib.c	2017-04-25 16:23:40.186527335 +0200
@@ -56,30 +56,44 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DH
 #include <openssl/bn.h>
 #include <openssl/dh.h>
 #ifndef OPENSSL_NO_ENGINE
 #include <openssl/engine.h>
 #endif
 
-const char DH_version[]="Diffie-Hellman" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char DH_version[]="Diffie-Hellman" OPENSSL_VERSION_PTEXT;/* ARRAY OK 2008-02-26 haavardm */
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 static const DH_METHOD *default_DH_method = NULL;
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 void DH_set_default_method(const DH_METHOD *meth)
 	{
 	default_DH_method = meth;
 	}
+#endif
 
 const DH_METHOD *DH_get_default_method(void)
 	{
+#ifndef OPERA_SMALL_VERSION
 	if(!default_DH_method)
 		default_DH_method = DH_OpenSSL();
 	return default_DH_method;
+#else
+	return DH_OpenSSL();
+#endif
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int DH_set_method(DH *dh, const DH_METHOD *meth)
 	{
 	/* NB: The caller is specifically setting a method, so it's not up to us
@@ -98,6 +112,7 @@
         if (meth->init) meth->init(dh);
         return 1;
 	}
+#endif
 
 DH *DH_new(void)
 	{
@@ -245,3 +260,5 @@
 	{
 	return(BN_num_bytes(dh->p));
 	}
+
+#endif /* OPENSSL_NO_DH */
diff -Naur openssl-1.0.0q.orig/crypto/dh/dh_pmeth.c openssl-1.0.0q/crypto/dh/dh_pmeth.c
--- openssl-1.0.0q.orig/crypto/dh/dh_pmeth.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dh_pmeth.c	2017-04-25 16:23:40.187527182 +0200
@@ -55,14 +55,19 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/evp.h>
 #include <openssl/dh.h>
 #include <openssl/bn.h>
-#include "evp_locl.h"
+#include "../evp/evp_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* DH pkey context structure */
 
@@ -80,7 +85,7 @@
 static int pkey_dh_init(EVP_PKEY_CTX *ctx)
 	{
 	DH_PKEY_CTX *dctx;
-	dctx = OPENSSL_malloc(sizeof(DH_PKEY_CTX));
+	dctx = (DH_PKEY_CTX *)OPENSSL_malloc(sizeof(DH_PKEY_CTX));
 	if (!dctx)
 		return 0;
 	dctx->prime_len = 1024;
@@ -99,8 +104,8 @@
 	DH_PKEY_CTX *dctx, *sctx;
 	if (!pkey_dh_init(dst))
 		return 0;
-       	sctx = src->data;
-	dctx = dst->data;
+       	sctx = (DH_PKEY_CTX *)src->data;
+	dctx = (DH_PKEY_CTX *)dst->data;
 	dctx->prime_len = sctx->prime_len;
 	dctx->generator = sctx->generator;
 	dctx->use_dsa = sctx->use_dsa;
@@ -109,14 +114,14 @@
 
 static void pkey_dh_cleanup(EVP_PKEY_CTX *ctx)
 	{
-	DH_PKEY_CTX *dctx = ctx->data;
+	DH_PKEY_CTX *dctx = (DH_PKEY_CTX *)ctx->data;
 	if (dctx)
 		OPENSSL_free(dctx);
 	}
 
 static int pkey_dh_ctrl(EVP_PKEY_CTX *ctx, int type, int p1, void *p2)
 	{
-	DH_PKEY_CTX *dctx = ctx->data;
+	DH_PKEY_CTX *dctx = (DH_PKEY_CTX *)ctx->data;
 	switch (type)
 		{
 		case EVP_PKEY_CTRL_DH_PARAMGEN_PRIME_LEN:
@@ -161,7 +166,7 @@
 static int pkey_dh_paramgen(EVP_PKEY_CTX *ctx, EVP_PKEY *pkey)
 	{
 	DH *dh = NULL;
-	DH_PKEY_CTX *dctx = ctx->data;
+	DH_PKEY_CTX *dctx = (DH_PKEY_CTX *)ctx->data;
 	BN_GENCB *pcb, cb;
 	int ret;
 	if (ctx->pkey_gencb)
@@ -217,8 +222,7 @@
 	return 1;
 	}
 
-const EVP_PKEY_METHOD dh_pkey_meth = 
-	{
+CONST_EVP_PKEY_METHOD_ITEM(dh_pmeth__dh_pkey_meth,
 	EVP_PKEY_DH,
 	EVP_PKEY_FLAG_AUTOARGLEN,
 	pkey_dh_init,
@@ -251,4 +255,4 @@
 	pkey_dh_ctrl,
 	pkey_dh_ctrl_str
 
-	};
+	);
diff -Naur openssl-1.0.0q.orig/crypto/dh/dhtest.c openssl-1.0.0q/crypto/dh/dhtest.c
--- openssl-1.0.0q.orig/crypto/dh/dhtest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/dhtest.c	2017-04-25 16:23:40.188526472 +0200
@@ -56,6 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 /* Until the key-gen callbacks are modified to use newer prototypes, we allow
  * deprecated functions for openssl-internal code */
 #ifdef OPENSSL_NO_DEPRECATED
@@ -65,6 +69,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -170,7 +175,7 @@
 	BIO_puts(out,"key1 =");
 	for (i=0; i<aout; i++)
 		{
-		sprintf(buf,"%02X",abuf[i]);
+		op_sprintf(buf,"%02X",abuf[i]);
 		BIO_puts(out,buf);
 		}
 	BIO_puts(out,"\n");
@@ -182,11 +187,11 @@
 	BIO_puts(out,"key2 =");
 	for (i=0; i<bout; i++)
 		{
-		sprintf(buf,"%02X",bbuf[i]);
+		op_sprintf(buf,"%02X",bbuf[i]);
 		BIO_puts(out,buf);
 		}
 	BIO_puts(out,"\n");
-	if ((aout < 4) || (bout != aout) || (memcmp(abuf,bbuf,aout) != 0))
+	if ((aout < 4) || (bout != aout) || (op_memcmp(abuf,bbuf,aout) != 0))
 		{
 		fprintf(stderr,"Error in DH routines\n");
 		ret=1;
diff -Naur openssl-1.0.0q.orig/crypto/dh/p1024.c openssl-1.0.0q/crypto/dh/p1024.c
--- openssl-1.0.0q.orig/crypto/dh/p1024.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/p1024.c	2017-04-25 16:23:40.192527539 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/bn.h>
 #include <openssl/asn1.h>
 #include <openssl/dh.h>
diff -Naur openssl-1.0.0q.orig/crypto/dh/p192.c openssl-1.0.0q/crypto/dh/p192.c
--- openssl-1.0.0q.orig/crypto/dh/p192.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/p192.c	2017-04-25 16:23:40.193526828 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/bn.h>
 #include <openssl/asn1.h>
 #include <openssl/dh.h>
diff -Naur openssl-1.0.0q.orig/crypto/dh/p512.c openssl-1.0.0q/crypto/dh/p512.c
--- openssl-1.0.0q.orig/crypto/dh/p512.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dh/p512.c	2017-04-25 16:23:40.194529469 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/bn.h>
 #include <openssl/asn1.h>
 #include <openssl/dh.h>
diff -Naur openssl-1.0.0q.orig/crypto/dsa/.gitignore openssl-1.0.0q/crypto/dsa/.gitignore
--- openssl-1.0.0q.orig/crypto/dsa/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/.gitignore	2017-04-25 16:23:40.195527920 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_ameth.c openssl-1.0.0q/crypto/dsa/dsa_ameth.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_ameth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_ameth.c	2017-04-25 16:23:40.196527488 +0200
@@ -55,8 +55,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
 #include <openssl/dsa.h>
@@ -64,7 +67,9 @@
 #ifndef OPENSSL_NO_CMS
 #include <openssl/cms.h>
 #endif
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int dsa_pub_decode(EVP_PKEY *pkey, X509_PUBKEY *pubkey)
 	{
@@ -85,7 +90,7 @@
 
 	if (ptype == V_ASN1_SEQUENCE)
 		{
-		pstr = pval;	
+		pstr = (ASN1_STRING *)pval;
 		pm = pstr->data;
 		pmlen = pstr->length;
 
@@ -178,7 +183,7 @@
 	if (penc)
 		OPENSSL_free(penc);
 	if (pval)
-		ASN1_STRING_free(pval);
+		ASN1_STRING_free((ASN1_STRING *)pval);
 
 	return 0;
 	}
@@ -251,7 +256,7 @@
 			goto decerr;
 		}
 
-	pstr = pval;	
+	pstr = (ASN1_STRING *)pval;
 	pm = pstr->data;
 	pmlen = pstr->length;
 	if (!(dsa = d2i_DSAparams(NULL, &pm, pmlen)))
@@ -557,7 +562,7 @@
 			{
 			int snid, hnid;
 			X509_ALGOR *alg1, *alg2;
-			PKCS7_SIGNER_INFO_get0_algs(arg2, NULL, &alg1, &alg2);
+			PKCS7_SIGNER_INFO_get0_algs((PKCS7_SIGNER_INFO *)arg2, NULL, &alg1, &alg2);
 			if (alg1 == NULL || alg1->algorithm == NULL)
 				return -1;
 			hnid = OBJ_obj2nid(alg1->algorithm);
@@ -574,7 +579,7 @@
 			{
 			int snid, hnid;
 			X509_ALGOR *alg1, *alg2;
-			CMS_SignerInfo_get0_algs(arg2, NULL, NULL, &alg1, &alg2);
+			CMS_SignerInfo_get0_algs((CMS_SignerInfo *)arg2, NULL, NULL, &alg1, &alg2);
 			if (alg1 == NULL || alg1->algorithm == NULL)
 				return -1;
 			hnid = OBJ_obj2nid(alg1->algorithm);
@@ -600,40 +605,55 @@
 
 /* NB these are sorted in pkey_id order, lowest first */
 
-const EVP_PKEY_ASN1_METHOD dsa_asn1_meths[] = 
-	{
 
-		{
+
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dsa_ameth__dsa_asn1_meth0,
 		EVP_PKEY_DSA2,
 		EVP_PKEY_DSA,
 		ASN1_PKEY_ALIAS
-		},
+		// 21 zeros.
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0
+		);
 
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dsa_ameth__dsa_asn1_meth1,
 		EVP_PKEY_DSA1,
 		EVP_PKEY_DSA,
 		ASN1_PKEY_ALIAS
-		},
+		// 21 zeros.
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0
+		);
 
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dsa_ameth__dsa_asn1_meth2,
 		EVP_PKEY_DSA4,
 		EVP_PKEY_DSA,
 		ASN1_PKEY_ALIAS
-		},
+		// 21 zeros.
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0
+		);
 
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dsa_ameth__dsa_asn1_meth3,
 		EVP_PKEY_DSA3,
 		EVP_PKEY_DSA,
 		ASN1_PKEY_ALIAS
-		},
+		// 21 zeros.
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0
+		);
 
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(dsa_ameth__dsa_asn1_meth4,
 		EVP_PKEY_DSA,
 		EVP_PKEY_DSA,
 		0,
 
-		"DSA",
-		"OpenSSL DSA method",
+		(char *)"DSA",
+		(char *)"OpenSSL DSA method",
 
 		dsa_pub_decode,
 		dsa_pub_encode,
@@ -658,5 +678,4 @@
 		dsa_pkey_ctrl,
 		old_dsa_priv_decode,
 		old_dsa_priv_encode
-		}
-	};
+		);
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_asn1.c openssl-1.0.0q/crypto/dsa/dsa_asn1.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_asn1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_asn1.c	2017-04-25 16:23:40.197526777 +0200
@@ -56,19 +56,25 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Override the default new methods */
 static int sig_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
 								void *exarg)
 {
+	if(!pval)
+		return 0;
 	if(operation == ASN1_OP_NEW_PRE) {
 		DSA_SIG *sig;
-		sig = OPENSSL_malloc(sizeof(DSA_SIG));
+		sig = (DSA_SIG *) OPENSSL_malloc(sizeof(DSA_SIG));
 		if (!sig)
 			{
 			DSAerr(DSA_F_SIG_CB, ERR_R_MALLOC_FAILURE);
@@ -82,10 +88,10 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(DSA_SIG, sig_cb) = {
-	ASN1_SIMPLE(DSA_SIG, r, CBIGNUM),
+ASN1_SEQUENCE_cb(DSA_SIG, sig_cb)
+	ASN1_SIMPLE(DSA_SIG, r, CBIGNUM)
 	ASN1_SIMPLE(DSA_SIG, s, CBIGNUM)
-} ASN1_SEQUENCE_END_cb(DSA_SIG, DSA_SIG)
+ASN1_SEQUENCE_END_cb(DSA_SIG, DSA_SIG)
 
 IMPLEMENT_ASN1_FUNCTIONS_const(DSA_SIG)
 
@@ -105,24 +111,30 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(DSAPrivateKey, dsa_cb) = {
-	ASN1_SIMPLE(DSA, version, LONG),
-	ASN1_SIMPLE(DSA, p, BIGNUM),
-	ASN1_SIMPLE(DSA, q, BIGNUM),
-	ASN1_SIMPLE(DSA, g, BIGNUM),
-	ASN1_SIMPLE(DSA, pub_key, BIGNUM),
+ASN1_SEQUENCE_cb(DSAPrivateKey, dsa_cb)
+	ASN1_SIMPLE(DSA, version, LONG)
+	ASN1_SIMPLE(DSA, p, BIGNUM)
+	ASN1_SIMPLE(DSA, q, BIGNUM)
+	ASN1_SIMPLE(DSA, g, BIGNUM)
+	ASN1_SIMPLE(DSA, pub_key, BIGNUM)
 	ASN1_SIMPLE(DSA, priv_key, BIGNUM)
-} ASN1_SEQUENCE_END_cb(DSA, DSAPrivateKey)
+ASN1_SEQUENCE_END_cb(DSA, DSAPrivateKey)
 
-IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname(DSA, DSAPrivateKey, DSAPrivateKey)
-
-ASN1_SEQUENCE_cb(DSAparams, dsa_cb) = {
-	ASN1_SIMPLE(DSA, p, BIGNUM),
-	ASN1_SIMPLE(DSA, q, BIGNUM),
-	ASN1_SIMPLE(DSA, g, BIGNUM),
-} ASN1_SEQUENCE_END_cb(DSA, DSAparams)
+#if defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+#define DSA_IMPLEMENT_ENCODE IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname
+#else
+#define DSA_IMPLEMENT_ENCODE IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname1
+#endif
+
+DSA_IMPLEMENT_ENCODE(DSA, DSAPrivateKey, DSAPrivateKey)
+
+ASN1_SEQUENCE_cb(DSAparams, dsa_cb)
+	ASN1_SIMPLE(DSA, p, BIGNUM)
+	ASN1_SIMPLE(DSA, q, BIGNUM)
+	ASN1_SIMPLE(DSA, g, BIGNUM)
+ASN1_SEQUENCE_END_cb(DSA, DSAparams)
 
-IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname(DSA, DSAparams, DSAparams)
+DSA_IMPLEMENT_ENCODE(DSA, DSAparams, DSAparams)
 
 /* DSA public key is a bit trickier... its effectively a CHOICE type
  * decided by a field called write_params which can either write out
@@ -130,21 +142,22 @@
  * in a SEQUENCE
  */
 
-ASN1_SEQUENCE(dsa_pub_internal) = {
-	ASN1_SIMPLE(DSA, pub_key, BIGNUM),
-	ASN1_SIMPLE(DSA, p, BIGNUM),
-	ASN1_SIMPLE(DSA, q, BIGNUM),
+ASN1_SEQUENCE(dsa_pub_internal) 
+	ASN1_SIMPLE(DSA, pub_key, BIGNUM)
+	ASN1_SIMPLE(DSA, p, BIGNUM)
+	ASN1_SIMPLE(DSA, q, BIGNUM)
 	ASN1_SIMPLE(DSA, g, BIGNUM)
-} ASN1_SEQUENCE_END_name(DSA, dsa_pub_internal)
+ASN1_SEQUENCE_END_name(DSA, dsa_pub_internal)
 
-ASN1_CHOICE_cb(DSAPublicKey, dsa_cb) = {
-	ASN1_SIMPLE(DSA, pub_key, BIGNUM),
+ASN1_CHOICE_cb(DSAPublicKey, dsa_cb)
+	ASN1_SIMPLE(DSA, pub_key, BIGNUM)
 	ASN1_EX_COMBINE(0, 0, dsa_pub_internal)
-} ASN1_CHOICE_END_cb(DSA, DSAPublicKey, write_params)
+ASN1_CHOICE_END_cb(DSA, DSAPublicKey, write_params)
 
 IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname(DSA, DSAPublicKey, DSAPublicKey)
 
 DSA *DSAparams_dup(DSA *dsa)
 	{
-	return ASN1_item_dup(ASN1_ITEM_rptr(DSAparams), dsa);
+	return (DSA *) ASN1_item_dup(ASN1_ITEM_rptr(DSAparams), dsa);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_err.c openssl-1.0.0q/crypto/dsa/dsa_err.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_err.c	2017-04-25 16:23:40.198528301 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/dsa.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_gen.c openssl-1.0.0q/crypto/dsa/dsa_gen.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_gen.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_gen.c	2017-04-25 16:23:40.205527235 +0200
@@ -73,8 +73,10 @@
 
 #ifndef OPENSSL_NO_SHA
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/bn.h>
 #include <openssl/rand.h>
@@ -190,8 +192,8 @@
 				seed_is_random = 0;
 				seed_len=0; /* use random seed if 'seed_in' turns out to be bad*/
 				}
-			memcpy(buf , seed, qsize);
-			memcpy(buf2, seed, qsize);
+			op_memcpy(buf , seed, qsize);
+			op_memcpy(buf2, seed, qsize);
 			/* precompute "SEED + 1" for step 7: */
 			for (i = qsize-1; i >= 0; i--)
 				{
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_key.c openssl-1.0.0q/crypto/dsa/dsa_key.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_key.c	2017-04-25 16:23:40.206527363 +0200
@@ -56,9 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #ifndef OPENSSL_NO_SHA
 #include <openssl/bn.h>
 #include <openssl/dsa.h>
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_lib.c openssl-1.0.0q/crypto/dsa/dsa_lib.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_lib.c	2017-04-25 16:23:40.207528049 +0200
@@ -58,8 +58,11 @@
 
 /* Original version from Steven Schoch <schoch@sheba.arc.nasa.gov> */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DSA
 #include <openssl/bn.h>
 #include <openssl/dsa.h>
 #include <openssl/asn1.h>
@@ -70,20 +73,30 @@
 #include <openssl/dh.h>
 #endif
 
-const char DSA_version[]="DSA" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char DSA_version[]="DSA" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-26 haavardm */
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 static const DSA_METHOD *default_DSA_method = NULL;
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 void DSA_set_default_method(const DSA_METHOD *meth)
 	{
 	default_DSA_method = meth;
 	}
+#endif
 
 const DSA_METHOD *DSA_get_default_method(void)
 	{
+#ifndef OPERA_SMALL_VERSION
 	if(!default_DSA_method)
 		default_DSA_method = DSA_OpenSSL();
 	return default_DSA_method;
+#else
+	return DSA_OpenSSL();
+#endif
 	}
 
 DSA *DSA_new(void)
@@ -91,6 +104,7 @@
 	return DSA_new_method(NULL);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int DSA_set_method(DSA *dsa, const DSA_METHOD *meth)
 	{
 	/* NB: The caller is specifically setting a method, so it's not up to us
@@ -109,6 +123,7 @@
         if (meth->init) meth->init(dsa);
         return 1;
 	}
+#endif
 
 DSA *DSA_new_method(ENGINE *engine)
 	{
@@ -255,6 +270,7 @@
 	return(ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int DSA_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func,
 	     CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
         {
@@ -309,3 +325,5 @@
 	return NULL;
 	}
 #endif
+#endif
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_ossl.c openssl-1.0.0q/crypto/dsa/dsa_ossl.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_ossl.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_ossl.c	2017-04-25 16:23:40.208527337 +0200
@@ -58,13 +58,17 @@
 
 /* Original version from Steven Schoch <schoch@sheba.arc.nasa.gov> */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DSA
 #include <openssl/bn.h>
 #include <openssl/sha.h>
 #include <openssl/dsa.h>
 #include <openssl/rand.h>
 #include <openssl/asn1.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static DSA_SIG *dsa_do_sign(const unsigned char *dgst, int dlen, DSA *dsa);
 static int dsa_sign_setup(DSA *dsa, BN_CTX *ctx_in, BIGNUM **kinvp, BIGNUM **rp);
@@ -73,20 +77,20 @@
 static int dsa_init(DSA *dsa);
 static int dsa_finish(DSA *dsa);
 
-static DSA_METHOD openssl_dsa_meth = {
-"OpenSSL DSA method",
-dsa_do_sign,
-dsa_sign_setup,
-dsa_do_verify,
-NULL, /* dsa_mod_exp, */
-NULL, /* dsa_bn_mod_exp, */
-dsa_init,
-dsa_finish,
-0,
-NULL,
-NULL,
-NULL
-};
+OPENSSL_PREFIX_CONST_ITEM(static, DSA_METHOD, openssl_dsa_meth, libopeay)
+  CONST_ITEM_ENTRY_START(name,OPERA_OPENSSL_STRINGS("OpenSSL DSA method"))
+  CONST_ITEM_ENTRY_SINGLE(dsa_do_sign, dsa_do_sign)
+  CONST_ITEM_ENTRY_SINGLE(dsa_sign_setup, dsa_sign_setup)
+  CONST_ITEM_ENTRY_SINGLE(dsa_do_verify, dsa_do_verify)
+  CONST_ITEM_ENTRY_SINGLE(dsa_mod_exp, NULL)
+  CONST_ITEM_ENTRY_SINGLE(bn_mod_exp, NULL)
+  CONST_ITEM_ENTRY_SINGLE(init, dsa_init)
+  CONST_ITEM_ENTRY_SINGLE(finish, dsa_finish)
+  CONST_ITEM_ENTRY_SINGLE(flags, 0)
+  CONST_ITEM_ENTRY_SINGLE(app_data, NULL)
+  CONST_ITEM_ENTRY_SINGLE(dsa_paramgen, NULL)
+  CONST_ITEM_ENTRY_SINGLE(dsa_keygen, NULL)
+CONST_ITEM_ENTRY_END;
 
 /* These macro wrappers replace attempts to use the dsa_mod_exp() and
  * bn_mod_exp() handlers in the DSA_METHOD structure. We avoid the problem of
@@ -125,7 +129,7 @@
 
 const DSA_METHOD *DSA_OpenSSL(void)
 {
-	return &openssl_dsa_meth;
+	return &OPENSSL_GLOBAL_ITEM_NAME(openssl_dsa_meth);
 }
 
 static DSA_SIG *dsa_do_sign(const unsigned char *dgst, int dlen, DSA *dsa)
@@ -395,4 +399,5 @@
 		BN_MONT_CTX_free(dsa->method_mont_p);
 	return(1);
 }
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_pmeth.c openssl-1.0.0q/crypto/dsa/dsa_pmeth.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_pmeth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_pmeth.c	2017-04-25 16:23:40.209527465 +0200
@@ -55,14 +55,19 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/evp.h>
 #include <openssl/bn.h>
-#include "evp_locl.h"
+#include "../evp/evp_locl.h"
 #include "dsa_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* DSA pkey context structure */
 
@@ -81,7 +86,7 @@
 static int pkey_dsa_init(EVP_PKEY_CTX *ctx)
 	{
 	DSA_PKEY_CTX *dctx;
-	dctx = OPENSSL_malloc(sizeof(DSA_PKEY_CTX));
+	dctx = (DSA_PKEY_CTX *)OPENSSL_malloc(sizeof(DSA_PKEY_CTX));
 	if (!dctx)
 		return 0;
 	dctx->nbits = 1024;
@@ -101,8 +106,8 @@
 	DSA_PKEY_CTX *dctx, *sctx;
 	if (!pkey_dsa_init(dst))
 		return 0;
-       	sctx = src->data;
-	dctx = dst->data;
+	sctx = (DSA_PKEY_CTX *)src->data;
+	dctx = (DSA_PKEY_CTX *)dst->data;
 	dctx->nbits = sctx->nbits;
 	dctx->qbits = sctx->qbits;
 	dctx->pmd = sctx->pmd;
@@ -112,7 +117,7 @@
 
 static void pkey_dsa_cleanup(EVP_PKEY_CTX *ctx)
 	{
-	DSA_PKEY_CTX *dctx = ctx->data;
+	DSA_PKEY_CTX *dctx = (DSA_PKEY_CTX *)ctx->data;
 	if (dctx)
 		OPENSSL_free(dctx);
 	}
@@ -122,7 +127,7 @@
 	{
 	int ret, type;
 	unsigned int sltmp;
-	DSA_PKEY_CTX *dctx = ctx->data;
+	DSA_PKEY_CTX *dctx = (DSA_PKEY_CTX *)ctx->data;
 	DSA *dsa = ctx->pkey->pkey.dsa;
 
 	if (dctx->md)
@@ -143,7 +148,7 @@
 					const unsigned char *tbs, size_t tbslen)
 	{
 	int ret, type;
-	DSA_PKEY_CTX *dctx = ctx->data;
+	DSA_PKEY_CTX *dctx = (DSA_PKEY_CTX *)ctx->data;
 	DSA *dsa = ctx->pkey->pkey.dsa;
 
 	if (dctx->md)
@@ -158,7 +163,7 @@
 
 static int pkey_dsa_ctrl(EVP_PKEY_CTX *ctx, int type, int p1, void *p2)
 	{
-	DSA_PKEY_CTX *dctx = ctx->data;
+	DSA_PKEY_CTX *dctx = (DSA_PKEY_CTX *)ctx->data;
 	switch (type)
 		{
 		case EVP_PKEY_CTRL_DSA_PARAMGEN_BITS:
@@ -181,7 +186,7 @@
 			DSAerr(DSA_F_PKEY_DSA_CTRL, DSA_R_INVALID_DIGEST_TYPE);
 			return 0;
 			}
-		dctx->md = p2;
+		dctx->md = (const EVP_MD *)p2;
 		return 1;
 
 		case EVP_PKEY_CTRL_MD:
@@ -194,7 +199,7 @@
 			DSAerr(DSA_F_PKEY_DSA_CTRL, DSA_R_INVALID_DIGEST_TYPE);
 			return 0;
 			}
-		dctx->md = p2;
+		dctx->md = (const EVP_MD *)p2;
 		return 1;
 
 		case EVP_PKEY_CTRL_DIGESTINIT:
@@ -239,7 +244,7 @@
 static int pkey_dsa_paramgen(EVP_PKEY_CTX *ctx, EVP_PKEY *pkey)
 	{
 	DSA *dsa = NULL;
-	DSA_PKEY_CTX *dctx = ctx->data;
+	DSA_PKEY_CTX *dctx = (DSA_PKEY_CTX *)ctx->data;
 	BN_GENCB *pcb, cb;
 	int ret;
 	if (ctx->pkey_gencb)
@@ -279,8 +284,7 @@
 	return DSA_generate_key(pkey->pkey.dsa);
 	}
 
-const EVP_PKEY_METHOD dsa_pkey_meth = 
-	{
+CONST_EVP_PKEY_METHOD_ITEM(dsa_pmeth__dsa_pkey_meth,
 	EVP_PKEY_DSA,
 	EVP_PKEY_FLAG_AUTOARGLEN,
 	pkey_dsa_init,
@@ -313,4 +317,4 @@
 	pkey_dsa_ctrl_str
 
 
-	};
+	);
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_sign.c openssl-1.0.0q/crypto/dsa/dsa_sign.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_sign.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_sign.c	2017-04-25 16:23:40.210529268 +0200
@@ -58,7 +58,8 @@
 
 /* Original version from Steven Schoch <schoch@sheba.arc.nasa.gov> */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #include <openssl/rand.h>
 
@@ -88,3 +89,4 @@
 	return dsa->meth->dsa_sign_setup(dsa, ctx_in, kinvp, rp);
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsa_vrf.c openssl-1.0.0q/crypto/dsa/dsa_vrf.c
--- openssl-1.0.0q.orig/crypto/dsa/dsa_vrf.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsa_vrf.c	2017-04-25 16:23:40.211527998 +0200
@@ -58,7 +58,8 @@
 
 /* Original version from Steven Schoch <schoch@sheba.arc.nasa.gov> */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 
 int DSA_do_verify(const unsigned char *dgst, int dgst_len, DSA_SIG *sig,
@@ -99,3 +100,4 @@
 	DSA_SIG_free(s);
 	return(ret);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsagen.c openssl-1.0.0q/crypto/dsa/dsagen.c
--- openssl-1.0.0q.orig/crypto/dsa/dsagen.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsagen.c	2017-04-25 16:23:40.212527567 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/dsa.h>
 
 #define TEST
@@ -102,7 +104,7 @@
 	if (bio_err == NULL)
 		bio_err=BIO_new_fp(stderr,BIO_NOCLOSE);
 
-	memcpy(seed_buf,seed,20);
+	op_memcpy(seed_buf,seed,20);
 	dsa=DSA_generate_parameters(1024,seed,20,&counter,&h,cb,bio_err);
 
 	if (dsa == NULL)
